package parsec3

import net.sergeych.mptools.toDump
import net.sergeych.parsec3.MemoryKVStorage
import net.sergeych.parsec3.stored
import kotlin.test.Test
import kotlin.test.assertEquals
import kotlin.test.assertNull

internal class MemoryKVStorageTest {

    @Test
    fun testStorage() {
        val s = MemoryKVStorage()
        s.clear()
        println(s)
        println(s["foo"])
        s["foo"] = byteArrayOf(1,2,3)

        var bar: String? by s.stored(null)
        assertNull(bar)
        bar = "foo"
        println(s.get("bar")?.toDump())
        assertEquals("foo", bar)
        var foo: String by s.stored("", "bar")
        assertEquals("foo", foo)
//
//        var i: Int? by s(defaultValue = 17)
//        i = 19
//        var j: Int? by s("i")
//        assertEquals(19, j)

    }
}